// Advanced_faceStep.h: interface for the CFace_surfaceStep class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_Advanced_faceStepStep_H__9F9D4C73_0C2F_11D5_BFEF_0004AC6EEF35__INCLUDED_)
#define AFX_Advanced_faceStepStep_H__9F9D4C73_0C2F_11D5_BFEF_0004AC6EEF35__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CFace_boundStep;
class CFace_outer_boundStep;
class CCartesian_pointStep;
class CEdge_loopStep;
class CCartesian_pointStepPtrArray;
class CrcPtrArray;

#include "afx.h"
#include "FaceStep.h"
#include "Topological_representation_itemStep.h"
#include "SurfaceStep.h"

#include "stepArchive.h"

// mailto:heger_walter@hotmail.com

class CAdvanced_faceStep : public CFace_surfaceStep //
{
public:
	CAdvanced_faceStep (CBaseStep * pFrom, 
                      CFace_boundStep* p_face_bound, 
                      bool same_sense=true
                      , int iNumFB=1
                      );
	virtual ~CAdvanced_faceStep ();
	void Serialize( stepArchive &ar);
  bool m_bSame_sense;
  CSurfaceStep* m_pFace_geometry;
  
  HRESULT backPtr( CBaseStep*& prBrep);
	
  HRESULT AddFB( CFace_boundStep *p_face_bound
    , int &ri);

  virtual HRESULT contains( CCartesian_pointStep* pPoint
                          , containment& bContains
                          , double &              rdParam
                          );

	HRESULT trimEdge( CrcPtrArray *pIntersectionPts 
    , paramPtrArray& intersectionEdge
    , containment& bContains
    );

  virtual 
    HRESULT edgeXAdvanced( CEdge_loopStep*    pELoopN,      // loop corresponding to neg feature
                           double&            dStartParam,  // start parameter on line0
                           double&            dEndParam,    // end parameter on line0
                           CrcPtrArray*       pLoopIntersectionPoints,  // collection of intersection 
                                                                        //points on polygon
                           unsigned int &     riStartIndex, // index of startpoint
                           unsigned int &     riEndIndex    // index of endpoint
                         , CCartesian_pointStepPtrArray*& pCartesian_pointStepPtrArray
                         );

	HRESULT intersect( CAdvanced_faceStep*  pAdvanced_faceStepOnNegFeature
                   , t_aEdge_loopStep&    aEdge_loopStep
                   );

};

//////////////////////////////////////////////////////////
// who  date      history
// wh   10/22/01  face_surface::split does not return another face_surface
	
#endif // !defined(AFX_Advanced_faceStepStep_H__9F9D4C73_0C2F_11D5_BFEF_0004AC6EEF35__INCLUDED_)
