// Csg_shape_representationStep.cpp: implementation of the CCsg_shape_representationStep class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "scribble.h"
#include "Csg_shape_representationStep.h"
#include "Representation_itemStep.h"
#include "Representation_contextStep.h"
#include "Csg_solidStep.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCsg_shape_representationStep::CCsg_shape_representationStep(
                                                              t_aCsg_solidStep           * p_Csg_solidSteps           , 
                                                              CRepresentation_contextStep*     pRepresentative_context, 
                                                              step                       *     pStep                  )
: CShape_representationStep(NULL)
, m_szName("")
, m_pContext_of_items( pRepresentative_context    )
{
  nameClass("Csg_shape_representation");
  for (int i=0; i< p_Csg_solidSteps->GetSize(); i++) {
    m_aCsg_solidStep.Add( p_Csg_solidSteps->GetAt(i));
  }
}

CCsg_shape_representationStep::~CCsg_shape_representationStep()
{

}

HRESULT CCsg_shape_representationStep::backPtr(CBaseStep *&prBrep)
{
  prBrep = m_pParent;  
  return S_OK;
}

void CCsg_shape_representationStep::Serialize(stepArchive &ar)
{
  try{
    if (!isSerialized()){
      setSerialized();
      writePre(ar);
      ar <<   "''," ;
      if (0 < m_aCsg_solidStep.GetSize()){
        writeNtuple( ar, &m_aCsg_solidStep, m_aCsg_solidStep.GetSize());
      }
      else{
        ar << "($)" ;
      }
      ar << ",#" ;
      ar << m_pContext_of_items->getNum();
      writePost(ar);

      for (int i =0; i< m_aCsg_solidStep.GetSize(); i++){
        CCsg_solidStep* p_Csg_solidStep= 
          (CCsg_solidStep* ) m_aCsg_solidStep.GetAt(i);
        p_Csg_solidStep->Serialize(ar);
      }
      m_pContext_of_items->Serialize(ar);
    }
  }
  catch(...){
    ar << "\n/*Errors detected in "<< this->getClassName()<<"::Serialize #\n";
//  ar << getNum();
    ar <<   ", but continuing*/\n" ;    
    setSerialized();
  }

}


