//
#include <LIMITS.H>//UINT_MAX
#include <FLOAT.H>// DBL_MAX, FLT_MAX
#include "math.h"// fabs
#include "afxwin.h"                                    
#include "stdafx.h" 
#include "scribble.h"
#include "stepArchive.h"
#include "ScribVw.h"
#include "StepSer.h"
#include "agito.h"


#include "Csg_solidStep.h"
#include "BlockStep.h"
#include "Boolean_resultStep.h"
#include "Boolean_operatorStep.h"
#include "Boolean_operandStep.h"
#include "Csg_primativeStep.h"
#include "Csg_selectStep.h"
#include "Csg_SolidStep.h"
#include "Csg_shape_representationStep.h"
#include "Axis2_placement_3dStep.h"
#include "Cartesian_pointStep.h"
#include "DirectionStep.h"

//http://www.mel.nist.gov/step/parts/part515/is/wg12n417.exp
HRESULT step::buildCsg( FILE *                stream, 
                        stepArchive &         ar, 
                        CRepresentationStep*& pRepresentationStep )
{
  HRESULT hr = S_OK;
  agitoAssembly  aAssembly ;
  for ( int im = 0; im <  GetScribView()->m_modelarray.GetSize();im++ ) {
    CModel* pModel= (CModel* )GetScribView()->m_modelarray.GetAt(im);
    if (pModel->on){
      agitoComponent* pLump= new agitoComponent;// a lump has features (things)
      if (NULL==pLump){
        return E_OUTOFMEMORY;
      }
      agitoPart* pPart= new agitoPart;// a part (model) has lumps
      if (NULL==pPart){
        return E_OUTOFMEMORY;
      }
      pPart->Add(pLump);
      aAssembly.Add( (LPVOID) pPart);
    }
  }// next im

  for ( int it = 0; it <  GetScribView()->m_thingarray.GetSize();it++ ) {
    CThing* pThing = (CThing*) GetScribView()->m_thingarray.GetAt(it);
    CModel* pModel= (CModel* )GetScribView()->m_modelarray.GetAt( pThing->BelongsToModelNo);    

    agitoPart* pPart = (agitoPart* )aAssembly.GetAt( pThing->BelongsToModelNo);
    ASSERT( 0 == pThing->BelongsToModelNo);
    agitoComponent* pLump = (agitoComponent* )pPart->GetAt( 0);

    agitoFeature* pFeature = new agitoFeature;
    pLump->Add(pFeature );
  }// next im

//agitoComponent aNegativeComponents;
  hr = 
    sortFeaturesCsg( stream, 
                     ar, 
                     pRepresentationStep, 
                     &aAssembly
                  //,aNegativeComponents
                    );    
  return S_OK;
}

HRESULT step::sortFeaturesCsg(  FILE *                stream, 
                                stepArchive &         ar, 
                                CRepresentationStep*& pRepresentationStep, 
                                agitoAssembly*                  pAssembly
                            //, agitoComponent&                 aNegativeComponents
                                )
{
  CCsg_selectStep* pLast = NULL;// the last entity inserted into the tree

  t_aCsg_solidStep aCsg_solidStep;

  for ( int im = 0; im <  GetScribView()->m_modelarray.GetSize();im++ ) {
    CCsg_selectStep *pCsg_selectStep = new CCsg_selectStep();
    CCsg_solidStep* pCsg_solidStep = new 
      CCsg_solidStep ();
    pCsg_solidStep->mp_tree_root_expression = pCsg_selectStep ;
    CCsg_primativeStep *pCsg_primativeStep = new CCsg_primativeStep();
    pCsg_selectStep->mp_select = pCsg_primativeStep; 

    //grepThing()
    CBlockStep *pBlockStep = new CBlockStep ();
    pBlockStep->x=1.0;
    pBlockStep->y=1.0;
    pBlockStep->z=1.0;

    CCartesian_pointStep*  pLocation       = new CCartesian_pointStep(NULL, 4.0);
    CDirectionStep*        pAxis           = new CDirectionStep(NULL, 2.0);
    CDirectionStep*        pRef_direction  = new CDirectionStep(NULL, 0.0, 3.0);

    CAxis2_placement_3dStep* pPosition = new CAxis2_placement_3dStep( pLocation, 
                                                                      pAxis           , 
                                                                      pRef_direction  );
    pBlockStep->mp_Position = pPosition;

//  pBlockStep->mp_Position->m_pRef_direction->m_direction_ratios>x=1.0;

    pCsg_primativeStep->mp_primative = pBlockStep;
    
    aCsg_solidStep.Add( pCsg_solidStep);

    CModel* pModel= (CModel*) GetScribView()->m_modelarray.GetAt( im);
    pModel->m_pCsgPool->AddStep( pCsg_solidStep);
//  pCsg_solidStep->m_pTechnadrawEntitites->AddTech( pModel);
    pLast = (CCsg_selectStep*) pCsg_solidStep->mp_tree_root_expression;
  }//im

//CCsg_selectStep& rRoot = *pLast ;

  for ( int it = 1; it < GetScribView()->m_thingarray.GetSize(); it++ ) {

    CThing* pThing = (CThing*)GetScribView()->m_thingarray.GetAt( it);
    agitoPart* pPart = (agitoPart* )pAssembly->GetAt( pThing->BelongsToModelNo);
    agitoComponent* pLump = (agitoComponent* )pPart->GetAt( 0);
    agitoFeature* pFeature = (agitoFeature* )pLump->GetAt( it);// fails for multi-parts
    bool bFeatureAdded=false;
    // find the negative feature
    for (int is = 0; is < GetScribView()->m_surfacearray.GetSize(); is++){
      CSurface* pSurface= (CSurface*)GetScribView()->m_surfacearray.GetAt(is);
      if ((it == pSurface->MemberOfObject)){
        CPolygon *pPolygon = (CPolygon *)GetScribView()->m_polygonarray.GetAt(pThing->firstpolyno);
        if (pPolygon->MemberOfSurface==is){
//        if (0 == stricmp(GetScribView()->att[pSurface->attindex].name, pThing->parameter[16]))
          {
            if (0.0 == pSurface->exists){
              if (!bFeatureAdded){
                bFeatureAdded = true;
                csgNode( stream, 
                         ar, 
                         pLast);
                ((CBoolean_resultStep *)pLast)->mp_Operator->m_op = op_difference;
                                
                goto foundFeature;
              }
            }
          }
        }
      }
    }
foundFeature:
    csgNode( stream, 
             ar, 
             pLast);


    if (1 == it){
      CCsg_solidStep* pCsg_solidStep = aCsg_solidStep.GetAt(0);
      ASSERT_VALID( pLast->mp_select);
      pCsg_solidStep->mp_tree_root_expression->mp_select = pLast->mp_select ;
    } else {
//      = pLast;
    }

  }

  CRepresentation_contextStep *pGeometric_representation_contextStep = new 
    CGeometric_representation_contextStep(NULL);

  pRepresentationStep = new 
    CCsg_shape_representationStep( &aCsg_solidStep//.GetAt(0)
                                 , pGeometric_representation_contextStep
                                 , this
                                 );
/*
   buildProductStructureAdvanced( stream 
                                , ar 
                                , im
                                , pRepresentationStep 
                                , csgModel
                                ); 
*/

  if (m_bWriteFile) 
  {
    pRepresentationStep->Serialize(ar); 
  }

  return S_OK;
}


HRESULT step::csgNode( FILE *            stream, 
                       stepArchive &     ar,
                       CCsg_selectStep*& pLast )
{
  CBaseStep *pPrimative = NULL;
  BOOL bFlag = true;
//flag = grepThing();
  if (bFlag ) {
    CBlockStep *pBlockStep = new CBlockStep ();
    pBlockStep->x=1.0;
    pBlockStep->y=1.0;
    pBlockStep->z=1.0;

    CCartesian_pointStep*  pLocation       = new CCartesian_pointStep(NULL, 4.0);
    CDirectionStep*        pAxis           = new CDirectionStep(NULL, 2.0);
    CDirectionStep*        pRef_direction  = new CDirectionStep(NULL, 0.0, 3.0);

    CAxis2_placement_3dStep* pPosition = new CAxis2_placement_3dStep( pLocation, 
                                                                      pAxis           , 
                                                                      pRef_direction  );
    pBlockStep->mp_Position = pPosition;

    pPrimative = pBlockStep ;

  } else {
    CBlockStep *pBlockStep = new CBlockStep ();
    pBlockStep->x=1.0;
    pBlockStep->y=1.0;
    pBlockStep->z=1.0;

    CCartesian_pointStep*  pLocation       = new CCartesian_pointStep(NULL, 4.0);
    CDirectionStep*        pAxis           = new CDirectionStep(NULL, 2.0);
    CDirectionStep*        pRef_direction  = new CDirectionStep(NULL, 0.0, 3.0);

    CAxis2_placement_3dStep* pPosition = new CAxis2_placement_3dStep( pLocation, 
                                                                      pAxis           , 
                                                                      pRef_direction  );
    pBlockStep->mp_Position = pPosition;

    pPrimative = pBlockStep ;
  } 

  CBoolean_resultStep *pBoolean_resultStep = new 
    CBoolean_resultStep();
  CBoolean_operandStep *pBoolean_operandStep1 = new CBoolean_operandStep();
  CBoolean_operandStep *pBoolean_operandStep2 = new CBoolean_operandStep();
  pBoolean_operandStep1->m_pChoice = (CGeometric_representation_itemStep *) pLast ;
  pBoolean_operandStep2->m_pChoice = (CGeometric_representation_itemStep *) pPrimative;
  pBoolean_resultStep->mp_first_operand  = pBoolean_operandStep1 ;
  pBoolean_resultStep->mp_second_operand = pBoolean_operandStep2;
  pBoolean_resultStep->mp_Operator = new CBoolean_operatorStep;
  pLast = (CCsg_selectStep*) pBoolean_resultStep;
  
  pBoolean_resultStep->Serialize(ar);
  return S_OK; 
}


//////////////////////////////////////////////////////////
// who  date      history
//-----------------------
// wh